<?php
include('includes/db.inc.php');
include('includes/auth.inc.php');
include('config/config.inc.php');
include('config/lang.inc.php');

include('includes/functions.inc.php');

require('Smarty.class.php');

$output = new Smarty;

$output->assign('self',basename($_SERVER['PHP_SELF']));
$output->assign('stylesheet','style.css');
$output->assign('results_per_page',array('5','10','20','50','100','200'));
$output->assign('pp_sel',$_POST['rpp'] ? $_POST['rpp'] : '20');
$output->assign('sent',$_POST['sent'] ? '1' : '0');


foreach ($text AS $tr_name => $tr_value) {
	$output->assign($tr_name,$tr_value);
}


$subject_length = 100; // Laenge, ab der der Betreff einer Mail abgeschnitten wird.
$pp             = $_POST['rpp']; // Ergebnisse pro Seite
$color1         = '#DDDDDD';
$color2         = '#DDDDFF';
$color          = $color1;

$page           = $_POST['page'] ? $_POST['page'] : 0;

if (isset($_POST['prev'])) {
	$page--;
}
if (isset($_POST['next'])) {
	$page++;
}

if (isset($_POST['newsearch'])) {
	$page = 0;
}


$query = "SELECT min(mtime) AS min FROM archiv;";
$res = $db->query($query);
$val = $res->fetchRow();
$firstdate = $val['min'];

$query = "SELECT max(mtime) AS max FROM archiv;";
$res = $db->query($query);
$val = $res->fetchRow();
$lastdate = $val['max'];

// Datumsangaben fuer das Formular
$temp = array();
for($i = date("Y",strtotime($firstdate)); $i <= date("Y",strtotime($lastdate)); $i++)
    $temp[] = $i;

$selected = $_POST['fromyear'] ? $_POST['fromyear'] : date("Y",strtotime($lastdate));
$output->assign('fromyear_sel',$selected);
$output->assign('fromyear',$temp);

$temp = array();
for($i = 1; $i <= 12; $i++)
    $temp[] = $i;

$selected = $_POST['frommonth'] ? $_POST['frommonth'] : date("n",strtotime($lastdate))-1;
$output->assign('frommonth_sel',$selected);
$output->assign('frommonth',$temp);


$temp = array();
for($i = 1; $i <= 31; $i++)
    $temp[] = $i;

$selected = $_POST['fromday'] ? $_POST['fromday'] : date("j",strtotime($lastdate));
$output->assign('fromday_sel',$selected);
$output->assign('fromday',$temp);

$temp = array();
for($i = date("Y",strtotime($firstdate)); $i <= date("Y",strtotime($lastdate)); $i++)
    $temp[] = $i;

$selected = $_POST['toyear'] ? $_POST['toyear'] : date("Y",strtotime($lastdate));
$output->assign('toyear_sel',$selected);
$output->assign('toyear',$temp);


$temp = array();
for($i = 1; $i <= 12; $i++)
    $temp[] = $i;

$selected = $_POST['tomonth'] ? $_POST['tomonth'] : date("n",strtotime($lastdate));
$output->assign('tomonth_sel',$selected);
$output->assign('tomonth',$temp);


$temp = array();
for($i = 1; $i <= 31; $i++)
    $temp[] = $i;

$selected = $_POST['today'] ? $_POST['today'] : date("j",strtotime($lastdate));
$output->assign('today_sel',$selected);
$output->assign('today',$temp);

if($_POST['sent']) {
	
	if ($_SESSION['class'] == 'lurker') {
		$query = "SELECT address.address AS adr
				  FROM address, access, users
				  WHERE address.id = access.addr_id
				  AND access.user_id = users.id
				  AND users.name = '".$_SESSION['uid']."'";
	
		$res = $db->query($query);

		$allowed = "(";
		
		while ($row = $res->fetchRow()) {
			if (strlen($row['adr']) > 0)
			$allowed .= "mfrom LIKE '%".$row['adr']."%' OR mto LIKE '%".$row['adr']."%' OR ";
		}
		$allowed = preg_replace('! OR $!', ')', $allowed);
	
	}

    $from = $_POST['fromyear']."-".$_POST['frommonth']."-".$_POST['fromday'];
    $to = $_POST['toyear']."-".$_POST['tomonth']."-".$_POST['today']." 23:59:59";

	
	if ($_POST['keyword']) {
		$wherekeyword = "(";
	    $wherekeyword .= $_POST['in_subject'] ? "subject LIKE '%".$_POST['keyword']."%' " : " 0 ";
    	$wherekeyword .= $_POST['in_from'] ? "OR mfrom LIKE '%".$_POST['keyword']."%' " : "OR 0 ";
    	$wherekeyword .= $_POST['in_to'] ? "OR mto LIKE '%".$_POST['keyword']."%')" : "OR 0) ";
	} else {
		$wherekeyword = "1";
	}
    
	$wheredate = "mtime >= '$from' AND mtime <= '$to' ";
	
	$whereaccess = ($_SESSION['class'] == 'admin' || $_SESSION['class'] == 'operator') 
	? "1" 
	: $allowed;
	
    $query = "SELECT count(*) AS count FROM archiv
               WHERE $wherekeyword
                 AND $wheredate";
    
	$result = $db->query($query);
    $row    = $result->fetchRow();
    $count  = $row['count'];

	
    $query = "SELECT * FROM archiv
               WHERE $wherekeyword
                 AND $wheredate
				 AND $whereaccess
            ORDER BY mtime DESC
               LIMIT ".$page*$pp.", $pp ";

    ?><!--<?= $query ?>--><?php

    $result = $db->query($query);
    $results = array();

    while($row = $result->fetchRow()) {

        $color = $color == $color1 ? $color2 : $color1;

        $subject = htmlspecialchars($row['subject']);
        if(strlen($subject) > $subject_length) {
            $subject = substr($subject,0,$subject_length)."...";
        }

        $temp = array();
        $temp['color']      = $color;
        $temp['id']         = $row['hash'];
        $temp['time']       = $row['mtime'];
        $temp['subject']    = htmlentities($subject);
        $temp['from']       = email(htmlentities($row['mfrom']));
        $temp['to']         = email(htmlentities($row['mto']));
        $temp['path']       = htmlentities($row['path']);
        $temp['fileexists'] = file_exists($row['path']);

        $results[] = $temp;
    }
    $output->assign('results',$results);

    $output->assign('keyword',$_POST['keyword']);
    $output->assign('page',$page);
    $output->assign('pagemore',$page+1);
    $output->assign('max_page',ceil($count/$pp));
    $output->assign('next_page',$page+1 < ceil($count/$pp) ? $page+1 : $page);
    $output->assign('prev_page',$page > 0 ? $page-1 : $page);
    $output->assign('res_count',$count);
	
	if (isset($_POST['in_subject']))
	    $output->assign('in_subject',1);
		
	if (isset($_POST['in_from'])) 
	    $output->assign('in_from',1);
		
	if (isset($_POST['in_to'])) 
	    $output->assign('in_to',1);
} else {
	$output->assign('in_subject',1);
	$output->assign('in_from',1);
	$output->assign('in_to',1);
}


$output->display('search.tpl');

?>
