#
# Tabellenstruktur fr Tabelle access
#

CREATE TABLE access (
   user_id int(11) DEFAULT '0' NOT NULL,
   addr_id tinyint(4) DEFAULT '0' NOT NULL
);
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle address
#

CREATE TABLE address (
   id tinyint(4) DEFAULT '0' NOT NULL auto_increment,
   address varchar(50) NOT NULL,
   PRIMARY KEY (id)
);
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle archiv
#

CREATE TABLE archiv (
   hash varchar(32) NOT NULL,
   mtime datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
   mfrom varchar(255) DEFAULT '<Leer>',
   mto varchar(255) DEFAULT '<Leer>',
   subject varchar(255) DEFAULT '<Leer>',
   message_id varchar(255) DEFAULT '<Leer>',
   path varchar(255) NOT NULL,
   PRIMARY KEY (hash)
);
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle users
#

CREATE TABLE users (
   id int(11) DEFAULT '0' NOT NULL auto_increment,
   name varchar(30) NOT NULL,
   password varchar(40) NOT NULL,
   class enum('admin','op','lurker') DEFAULT 'lurker',
   PRIMARY KEY (id)
);
